Bug 284708 - Lens Autocorrection overcompensates distortion
Summary: Lens Autocorrection overcompensates distortion
Status: RESOLVED FIXED
Alias: None
Product: digikam
Classification: Unclassified
Component: Plugin-Editor-LensCorrection (show other bugs)
Version: 2.1.1
Platform: Ubuntu Packages Linux
: NOR normal with 20 votes (vote)
Target Milestone: ---
Assignee: Digikam Developers
URL:
Keywords:
Depends on: 312764
Blocks:
  Show dependency treegraph
 
Reported: 2011-10-22 15:17 UTC by 202020
Modified: 2016-07-01 09:22 UTC (History)
1 user (show)

See Also:
Latest Commit:
Version Fixed In: 3.0.0


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description 202020 2011-10-22 15:17:26 UTC
Version:           2.1.1 (using KDE 4.7.1) 
OS:                Linux

Enhance > Lens > Autocorrection overcompensates distortions.


Reproducible: Always

Steps to Reproduce:
start showfoto with any image which has exif data.
The same problem when you enter parameters manually.

Actual Results:  
Barrel distortion becomes pincushion distortion

Expected Results:  
Barrel distortion should become straight grid

If you change in lensfun/slr-nikon.xml (I assume that would hold for any other
parameter file) the cropfactor for all lenses from 1.5 to 1.0 and keep the original cropfactor for the camera description, then there is no overcompensation and the expected result is delivered.
Comment 1 caulier.gilles 2013-01-07 10:23:46 UTC
Git commit 8b3eb6f0b498ae11729e0880e7ac0673b2dd2bd8 by Gilles Caulier.
Committed on 07/01/2013 at 11:16.
Pushed by cgilles into branch 'master'.

Apply patch #76254 from Roman I Khimov about lensfun interface which don't mangle cropFactor if it's set.
This behaviour was introduced by polish commit bebef401e147a00f859cb81774f8498a0623eee5.
With this branch present we always get cropFactor of
-1.0 in LensFunFilter::filterImage() and given that lensfun library just uses
crop factor of 1 which leads to obviously wrong calculations for cropped
cameras.
Related: bug 312764, bug 253941, bug 266204, bug 267613, bug 281783
FIXED-IN: 3.0.0
CCMAIL: rik@osrc.info

M  +0    -4    libs/dimg/filters/lens/lensfuncameraselector.cpp

http://commits.kde.org/digikam/8b3eb6f0b498ae11729e0880e7ac0673b2dd2bd8
Comment 2 caulier.gilles 2013-01-07 10:37:44 UTC
Git commit 613d004121682d122e9ea7fd9041a7bbc49acb89 by Gilles Caulier.
Committed on 07/01/2013 at 11:34.
Pushed by cgilles into branch 'master'.

Apply patch #76256 from Roman I Khimov to use crop factor from camera, not from lens data.
Lens crop factor in DB only tells us which crop factor was used for lens
calibration data, but it has nothing to do with shots made on random user's
camera. So the default behaviour should be to use camera's crop factor and only
fallback to lens data if there in no data present for camera. As "this should
not happen" it's appropriate to spit out some debug message in this case.

Ref: http://lensfun.berlios.de/manual/el_lens.html
Ref: http://lensfun.berlios.de/manual/el_camera.html
Related: bug 312766, bug 312764, bug 253941, bug 266204, bug 267613, bug 281783
FIXED-IN: 3.0.0
CCMAIL: roman@khimov.ru

M  +2    -1    libs/dimg/filters/lens/lensfuncameraselector.cpp
M  +1    -1    libs/dimg/filters/lens/lensfuniface.cpp

http://commits.kde.org/digikam/613d004121682d122e9ea7fd9041a7bbc49acb89
Comment 3 caulier.gilles 2013-01-07 10:41:51 UTC
Git commit 70cf9beaac9996c219f988d8ae74d75dc253c0ad by Gilles Caulier.
Committed on 07/01/2013 at 11:39.
Pushed by cgilles into branch 'master'.

Apply patch #76255 from Roman I Khimov to don't pass crop factor as scale factor to lensfun.

Sixth parameter to Initialize() is actually a scale factor which has nothing
in common with crop factor. I think it's safe to assume that we want no
scaling from lensfun and thus use the value of one.

Ref: http://lensfun.berlios.de/manual/structlfModifier.html
Related: bug 312765, bug 312764, bug 253941, bug 266204, bug 267613, bug 281783
FIXED-IN: 3.0.0
CCMAIL: roman@khimov.ru

M  +1    -1    libs/dimg/filters/lens/lensfunfilter.cpp

http://commits.kde.org/digikam/70cf9beaac9996c219f988d8ae74d75dc253c0ad